upload_mega.sh 8.9 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301
  1. #!/bin/bash
  2. set -e
  3. version=5.2
  4. date=28/10/2021
  5. pi7z_i=""
  6. swap_was="0"
  7. ftp_i=0
  8. pv_i=0
  9. cifs_i=0
  10. retry_flag=0
  11. daemon_on=0
  12. split_size=300
  13. echo -e "$(tput setaf 5)"
  14. echo -e " ╔╗ ╔═╗╔═╗╔╦╗╔═╗╔╦╗╦═╗╔═╗╔═╗"
  15. echo -e " ╠╩╗║ ║║ ║ ║ ╚═╗ ║ ╠╦╝╠═╣╠═╝"
  16. echo -e " ╚═╝╚═╝╚═╝ ╩ ╚═╝ ╩ ╩╚═╩ ╩╩ "
  17. echo -e " ╔╗ ╦ ╦╦╦ ╔╦╗╔═╗╦═╗ "
  18. echo -e " ╠╩╗║ ║║║ ║║║╣ ╠╦╝ "
  19. echo -e " ╚═╝╚═╝╩╩═╝═╩╝╚═╝╩╚═ "
  20. echo -e ""
  21. echo -e "\e[97mOkcash Blockchain Uploader v$version ($date)\e[0m"
  22. echo -e "Author : wareck@gmail.com"
  23. echo -e ""
  24. echo -e "Upload : Mega.nz"
  25. echo -e "Format : tar.xz"
  26. echo -e "Packet Size : $split_size Mo"
  27. echo -e ""
  28. sleep 4
  29. function init {
  30. if ps -ef | grep -v grep | grep okcashd >/dev/null
  31. then
  32. daemon_on=1
  33. echo -e "\n\e[93mStopping Okcashd :\e[0m"
  34. okcashd stop 2>/dev/null || true && sudo /etc/init.d/cron stop 2>/dev/null || true
  35. sleep 2
  36. if ps -ef | grep -v grep | grep okcashd >/dev/null ; then killall -9 okcashd; fi
  37. sleep 2
  38. if [ -f /usr/local/bin/okcashd ];then sudo mv /usr/local/bin/okcashd /usr/local/bin/okcashd_old |true ;fi
  39. if ps -ef | grep -v grep | grep okcashd >/dev/null ; then killall -9 okcashd; fi
  40. echo "Done."
  41. fi
  42. if [ "`systemctl is-active watchdog.service`" = "active" ]
  43. then
  44. echo -e "\n\e[93mStopping watchdog :\e[0m"
  45. sudo systemctl stop watchdog >/dev/null
  46. echo "Done."
  47. fi
  48. if [ -d /home/$USER/scripts/ledstatus/ ];then sudo python /home/$USER/scripts/ledstatus/led_off.py; fi
  49. if [ -f /var/swap ]
  50. then
  51. echo -e "\n\e[93mStopping Swap :\e[0m"
  52. sudo dphys-swapfile swapoff /var/swap
  53. sudo rm /var/swap
  54. swap_was="1"
  55. echo "Done."
  56. fi
  57. }
  58. function check_software_ {
  59. echo -e "\n\e[95mChecking Softwares :\e[0m"
  60. echo -e -n "Check PI7Z installed : "
  61. if ! [ -x "$(command -v 7z)" ]; then pi7z_i="p7zip-full" && echo -e "[\e[91m NO \e[0m]"; else pi7z_i="" && echo -e "[\e[92m YES \e[0m]"; fi
  62. echo -e -n "Check LFTP installed : "
  63. if ! [ -x "$(command -v lftp)" ]; then ftp_i="lftp" && echo -e "[\e[91m NO \e[0m]"; else ftp_i="" && echo -e "[\e[92m YES \e[0m]"; fi
  64. echo -e -n "Check CIFS installed : "
  65. if ! [ -x "$(command -v cifscreds)" ]; then cifs_i="cifs-utils" && echo -e "[\e[91m NO \e[0m]"; else cifs_i="" && echo -e "[\e[92m YES \e[0m]"; fi
  66. echo -e -n "Check PV installed : "
  67. if ! [ -x "$(command -v pv)" ]; then pv_i="pv" && echo -e "[\e[91m NO \e[0m]"; else pv_i="" && echo -e "[\e[92m YES \e[0m]"; fi
  68. if [[ ! $ftp_i = "" || ! $pi7z_i = "" || ! $pv_i = "" || ! $cifs_i = "" ]]
  69. then
  70. echo -e "\n\e[95mSoftwares update & install :\e[0m"
  71. sudo apt-get update
  72. sudo apt install $pi7z_i $ftp_i $pv_i $cifs_i cifs-utils -y
  73. check_software_
  74. fi
  75. echo -e "Done."
  76. }
  77. function freeze_on {
  78. NEW_FAN=5.0
  79. if [ -f /home/$USER/scripts/run-fan.py ]
  80. then
  81. echo -e "\n\e[95mEnable \e[38;5;196mF\e[38;5;202mr\e[38;5;208me\e[38;5;214me\e[38;5;220mz\e[38;5;226mi\e[38;5;227mn\e[38;5;229mg\e[0m \e[95m:\e[0m"
  82. sudo systemctl stop run-fan.service
  83. if ! [ -f /home/$USER/freeze.txt ]
  84. then
  85. if grep "# Author: Andreas Spiess" /home/$USER/scripts/run-fan.py >/dev/null
  86. then
  87. grep -i "desiredTemp = " /home/$USER/scripts/run-fan.py |awk 'NR==1 {print$3;exit}' >/home/$USER/freeze.txt
  88. else
  89. grep -i "self.startTemperature = " /home/$USER/scripts/run-fan.py |awk 'NR==1 {print$3;exit}' >/home/$USER/freeze.txt
  90. fi
  91. fi
  92. OLD_FAN=`cat /home/$USER/freeze.txt| awk '{print $1}'`
  93. echo "Fan PWM value : $OLD_FAN => $NEW_FAN"
  94. if grep "# Author: Andreas Spiess" ~/scripts/run-fan.py >/dev/null
  95. then
  96. sed -i -e "s/desiredTemp = "$OLD_FAN"/desiredTemp = "$NEW_FAN"/g" /home/$USER/scripts/run-fan.py
  97. else
  98. sed -i -e "s/self.startTemperature = "$OLD_FAN"/self.startTemperature = "$NEW_FAN"/g" /home/$USER/scripts/run-fan.py
  99. fi
  100. sudo systemctl restart run-fan.service
  101. echo -e "Done."
  102. sleep 1
  103. fi
  104. }
  105. function freeze_off {
  106. echo -e -n ""
  107. if [ -f /home/$USER/scripts/run-fan.py ]
  108. then
  109. echo -e "\n\e[95mDisable Freezing :\e[0m"
  110. OLD_FAN=`cat /home/$USER/freeze.txt| awk '{print $1}'`
  111. if grep "# Author: Andreas Spiess" ~/scripts/run-fan.py >/dev/null
  112. then
  113. echo "Fan PWM value : $NEW_FAN => $OLD_FAN"
  114. else
  115. echo "Fan value: $NEW_FAN =>$OLD_FAN"
  116. fi
  117. sudo systemctl stop run-fan.service
  118. if grep "# Author: Andreas Spiess" ~/scripts/run-fan.py >/dev/null
  119. then
  120. sed -i -e "s/desiredTemp = "$NEW_FAN"/desiredTemp = "$OLD_FAN"/g" /home/$USER/scripts/run-fan.py
  121. else
  122. sed -i -e "s/self.startTemperature = "$NEW_FAN"/self.startTemperature = "$OLD_FAN"/g" /home/$USER/scripts/run-fan.py
  123. fi
  124. sudo systemctl restart run-fan.service
  125. if [ -f /home/$USER/freeze.txt ];then rm /home/$USER/freeze.txt;fi
  126. echo -e "Done."
  127. fi
  128. }
  129. function packit {
  130. echo -e "\n\e[95mPacking & Compressing Files :\e[0m"
  131. cd /home/$USER
  132. #SIZE1=`du -sk /home/$USER/.okcash/blk0001.dat | cut -f 1`
  133. #SIZE2=`du -sk /home/$USER/.okcash/txleveldb/ | cut -f 1`
  134. #SIZET=$(($SIZE2+$SIZE1))
  135. #echo -e "\e[97mTar & PiXz bootstrap.tar.xz:\e[0m"
  136. echo -e "\e[97mCompress & split bootstrap.7z:\e[0m"
  137. split_size="${split_size}m"
  138. 7z a -v$split_size bootstrap .okcash/blk0001.dat .okcash/txleveldb/
  139. sleep 1
  140. echo "Done."
  141. #echo -e "\n\e[95mSplitting Files (${split_size}M):\e[0m"
  142. #split --verbose --numeric-suffixes=1 -b ${split_size}M bootstrap.tar.xz "bootstrap.part"
  143. #rm bootstrap.tar.xz
  144. #sleep 1
  145. #echo "Done."
  146. echo -e "\n\e[95mMake bootstrap_v.txt:\e[0m"
  147. if [ -f bootstrap_v.txt ]; then rm bootstrap_v.txt;fi
  148. Raw_date="`date +%d.%m.%Y`"
  149. YYYY=`ls -l bootstrap*.0* | wc -l`
  150. cat <<'EOF'>> bootstrap_v.txt
  151. Bootstrap : XXXX
  152. Parts: YYYY
  153. Size ; ZZZZ Mo
  154. EOF
  155. sed -i -e "s/XXXX/$Raw_date/g" bootstrap_v.txt
  156. sed -i -e "s/YYYY/$YYYY/g" bootstrap_v.txt
  157. sed -i -e "s/ZZZZ/$split_size" bootstrap_v.txt
  158. echo "Done."
  159. echo -e "\n\e[95mMd5sum Files:\e[0m"
  160. zap=$(ls -l bootstrap.7z.* | wc -l)
  161. for i in `seq -w 001 $zap`
  162. do
  163. echo -e -n "md5sum Bootstrap.7z.$i: " && md5sum bootstrap.7z.$i > bootstrap.$i.md5 && echo -e "\e[1mDone.\e[0m"
  164. done
  165. touch /home/$USER/bootstrap_uploadpass
  166. }
  167. function ftp_check {
  168. FTP_SUCCESS_MSG="226 Transfer complete"
  169. if fgrep "$FTP_SUCCESS_MSG" $Ftp_LOG ;then
  170. echo "ftp transfer : OK"
  171. echo ""
  172. rm $Ftp_LOG
  173. else
  174. echo "ftp transfer Error: $ftp_file"
  175. rm $Ftp_LOG
  176. echo ""
  177. ftp_loop
  178. fi
  179. }
  180. function ftp_loop {
  181. lftp -u wareck,zorn692611 ftpperso.free.fr <<EOF
  182. put $ftp_file -o /crypto/okcash/bootstrap/$ftp_file
  183. EOF
  184. echo -n $ftp_file && echo -e ": \e[1mDone.\e[0m";
  185. }
  186. function upload {
  187. cd /home/$USER
  188. echo -e "\n\e[95mUpload files to FTP server :\e[0m"
  189. ftp_file=bootstrap_v.txt && ftp_loop
  190. zap=$(ls -l bootstrap.7z.0* | wc -l)
  191. for j in `seq -w 001 $zap`
  192. do
  193. ftp_file=bootstrap.$j.md5
  194. ftp_loop
  195. done
  196. echo -e "\n\e[95mUpload files to Freebox :\e[0m"
  197. if ! [ -d /tmp/bootstrap ]; then mkdir /tmp/bootstrap ;fi
  198. if mount | grep -i "//mafreebox.freebox.fr/" >/dev/null
  199. then
  200. sudo umount /tmp/bootstrap/
  201. fi
  202. sudo mount -t cifs //mafreebox.freebox.fr/Disque\ dur/ /tmp/bootstrap/ -o user=freebox,password=password,uid=1000,gid=1000,rw,vers=1.0
  203. if ! [ -d /tmp/bootstrap/bootstrap ]; then mkdir /tmp/bootstrap/bootstrap ;fi
  204. cp -v bootstrap.7z.* /tmp/bootstrap/bootstrap/
  205. cp -v bootstrap_v.txt /tmp/bootstrap/bootstrap/
  206. cp -v bootstrap.*.md5 /tmp/bootstrap/bootstrap/
  207. if [ -f bootstrap_okcash ]
  208. then
  209. rm -r bootstrap_okcash
  210. fi
  211. git clone https://github.com/wareck/bootstrap_okcash.git
  212. cp -v bootstrap_v.txt bootstrap_okcash/
  213. cp -v bootstrap.*.md5 bootstrap_okcash/
  214. sleep 5
  215. sudo umount /tmp/bootstrap
  216. freeze_off
  217. echo -e "\n\e[92mUpload Done ...\n\e[0m"
  218. }
  219. function end_restart {
  220. if [ -f /usr/local/bin/okcashd_old ]
  221. then
  222. sudo mv /usr/local/bin/okcashd_old /usr/local/bin/okcashd | true
  223. okcashd
  224. fi
  225. }
  226. function retry {
  227. if [ -f /home/$USER/bootstrap_uploadpass ]; then retry_flag=1 ;fi
  228. if [ $retry_flag = "1" ]
  229. then
  230. echo -e "\n\e[95mRetry Upload to server :\e[0m"
  231. echo -e "Old files are still present."
  232. echo -e "If you want to force restart build/upload"
  233. echo -e "remove files by using this command:"
  234. echo -e ""
  235. echo -e "rm -r -f /home/$USER/bootstrap.7z.* /home/$USER/bootstrap_v.txt /home/$USER/bootstrap.7z.*.md5 /home/$USER/bootstrap_uploadpass"
  236. sleep 5
  237. fi
  238. }
  239. if ps -ef | grep -v grep | grep okcashd >/dev/null
  240. then
  241. echo -e "\n\e[38;5;166mOKcash daemon is working => shutdown and restart during this process !...\e[0m"
  242. while true; do
  243. read -p "Do you want to start processing (y/n) ? " yn
  244. case $yn in
  245. [Yy]* ) init ; check_software_; freeze_on ; retry ; packit ; upload ; end_restart ; break;;
  246. [Nn]* ) exit;;
  247. * ) echo "Please answer yes or no.";;
  248. esac
  249. done
  250. else
  251. init
  252. check_software_
  253. freeze_on
  254. retry
  255. if [ $retry_flag = "1" ]
  256. then
  257. upload
  258. end_restart
  259. else
  260. packit
  261. upload
  262. end_restart
  263. fi
  264. fi
  265. if [ swap_was = 1 ]
  266. then
  267. echo -e "\n\e[95mRestart Swap:\e[0m"
  268. sudo dphys-swapfile setup
  269. sudo dphys-swapfile swapon
  270. echo "Done."
  271. fi
  272. if [ -f /home/$USER/bootstrap_uploadpass ]; then rm /home/$USER/bootstrap_uploadpass;fi
  273. if [ $daemon_on = 1 ]
  274. then
  275. echo -e "\n\e[38;5;166mOKcash daemon is restarting ...\e[0m"
  276. if [ -f /usr/local/bin/okcashd_old ]
  277. then
  278. sudo mv /usr/local/bin/okcashd_old /usr/local/bin/okcashd | true
  279. fi
  280. fi
  281. echo ""